package cn.citycraft.SimpleProtect.command;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.SimpleProtect.SimpleProtect;

public class CommandDel extends BaseCommand {
	SimpleProtect plugin;

	public CommandDel(final SimpleProtect main) {
		super("delete", "del");
		this.plugin = main;
		setMinimumArguments(1);
		setDescription("解禁某个玩家");
		setPossibleArguments("<玩家名称>");
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		final String pname = args[0];
		final Player p = Bukkit.getPlayer(pname);
		if (p != null && plugin.spam.getCc().contains(p.getName())) {
			plugin.spam.getCc().remove(p);
			sender.sendMessage(plugin.getfullmsg("Spam.MuteOff").replace("%player%", p.getDisplayName()));
		} else {
			sender.sendMessage(plugin.getfullmsg("Spam.NotMute"));
		}
	}

}
