package cn.citycraft.SimpleProtect.command;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.PluginHelper.utils.StringUtil;
import cn.citycraft.SimpleProtect.SimpleProtect;

public class CommandList extends BaseCommand {
	SimpleProtect plugin;

	public CommandList(final SimpleProtect main) {
		super("list");
		this.plugin = main;
		setDescription("查看被禁言的玩家");
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		sender.sendMessage(plugin.getfullmsg("Spam.MutePlayer"));
		StringUtil.sendStringArray(sender, plugin.spam.getCc(), "§6 - ");
	}

	@Override
	public List<String> onTabComplete(final CommandSender sender, final Command command, final String label, final String[] args) {
		if (args.length < 1) {
			return null;
		}
		final String subcmd = args[0].toLowerCase();
		switch (subcmd) {
		case "add":
		case "del":
			return plugin.spam.getCc();
		case "admin":
			final List<String> tg = new ArrayList<String>();
			tg.add("on");
			tg.add("off");
			return tg;
		}
		return null;
	}

}
