/**
 *
 */
package cn.citycraft.SimpleProtect.command;

import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;

import cn.citycraft.PluginHelper.commands.DefaultCommand;
import cn.citycraft.PluginHelper.commands.HandlerSubCommand;
import cn.citycraft.SimpleProtect.SimpleProtect;

/**
 * @author Administrator
 *
 */
public class SimpleProtectCommand implements CommandExecutor, DefaultCommand {

	HandlerSubCommand hsc;

	SimpleProtect plugin;

	public SimpleProtectCommand(final SimpleProtect simpleProtect) {
		plugin = simpleProtect;
		hsc = new HandlerSubCommand(plugin);
		hsc.setDefaultCommand(this);
		hsc.registerCommand(new CommandAdd(plugin));
		hsc.registerCommand(new CommandAdmin(plugin));
		hsc.registerCommand(new CommandDel(plugin));
		hsc.registerCommand(new CommandList(plugin));
		hsc.registerCommand(new CommandReload(plugin));
		hsc.registerCommand(new CommandSetSpawn(plugin));
	}

	@Override
	public void defaultExecute(final CommandSender sender, final Command command, final String label) throws CommandException {
		hsc.sendHelp(sender, label);
	}

	@Override
	public boolean onCommand(final CommandSender sender, final Command command, final String label, final String[] args) {
		return hsc.onCommand(sender, command, label, args);
	}

}
