package cn.citycraft.SimpleProtect.listen;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map.Entry;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.BlockRedstoneEvent;

import cn.citycraft.SimpleProtect.SimpleProtect;

public class HighRedstone implements Runnable, Listener {

	HashMap<Block, Integer> map = new HashMap<Block, Integer>();
	SimpleProtect plugin;
	HashMap<Block, Player> pmap = new HashMap<Block, Player>();
	ArrayList<Player> tipop = new ArrayList<Player>();

	public HighRedstone(final SimpleProtect main) {
		plugin = main;
	}

	@EventHandler
	public void onRedClock(final BlockRedstoneEvent event) {
		final Block rb = event.getBlock();
		if (rb.getType() == Material.REDSTONE_WIRE) {
			put(event.getBlock());
		}
	}

	@EventHandler(ignoreCancelled = true)
	public void RedStonePlace(final BlockPlaceEvent event) {
		final Block rb = event.getBlock();
		final Player rp = event.getPlayer();
		if (rb.getType() == Material.REDSTONE_WIRE) {
			pmap.put(rb, rp);
		}
	}

	@Override
	public void run() {
		final List<Block> blocks = new ArrayList<Block>();
		for (final Entry<Block, Integer> entry : map.entrySet()) {
			if (entry.getValue() > plugin.config.getLong("HighRedstone.Maxevents")) {
				blocks.add(entry.getKey());
			}
		}
		Boolean tip = true;
		for (final Block block : blocks) {
			final World rw = block.getWorld();
			final int rx = block.getX();
			final int ry = block.getY();
			final int rz = block.getZ();
			final Player rp = pmap.get(block);
			if (rp != null) {
				if (rp.isOp() || rp.hasPermission("sp.ignore.highredstone")) {
					if (!tipop.contains(rp)) {
						rp.sendMessage(plugin.getfullmsg("HighRedstone.Admin"));
						tipop.add(rp);
					}
					continue;
				}
			}
			if (tip && plugin.config.getBoolean("HighRedstone.Tip")) {
				Bukkit.broadcastMessage(plugin.getfullmsg("HighRedstone.Find").replaceAll("%world%", rw.getName()).replaceAll("%x%", rx + "").replaceAll("%y%", ry + "").replaceAll("%z%", rz + ""));
				if (rp != null) {
					Bukkit.broadcastMessage(plugin.getfullmsg("HighRedstone.Check").replaceAll("%player%", rp.getName()));
					pmap.remove(block);
				}
				tip = !tip;
			}
			block.breakNaturally();
		}
		map.clear();
	}

	private void put(final Block block) {
		if (map.containsKey(block)) {
			final int i = map.remove(block);
			map.put(block, i + 1);
		} else {
			map.put(block, 1);
		}
	}
}
