package cn.citycraft.SimpleProtect.listen;

import java.util.Collection;
import java.util.Iterator;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.potion.PotionEffect;

import cn.citycraft.SimpleProtect.SimpleProtect;

public class Nightvision implements Listener {

	SimpleProtect plugin;

	public Nightvision(final SimpleProtect main) {
		plugin = main;
	}

	@EventHandler
	public void OnBlockBreak(final BlockBreakEvent e) {
		final Player p = e.getPlayer();
		if (p.hasPermission("sp.ignore.nightvision") || p.isOp()) {
			return;
		}
		final int light = p.getLocation().getBlock().getLightLevel();
		if (light > 0) {
			return;
		}
		final Block b = e.getBlock();
		final Material blockid = b.getType();
		final Location loc = b.getLocation();
		final World World = loc.getWorld();
		final int x = loc.getBlockX();
		final int y = loc.getBlockY();
		final int z = loc.getBlockZ();
		final Location loc_top = new Location(World, x, y + 1, z);
		if (loc_top.getBlock().getType() == Material.AIR) {
			return;
		}
		final Collection<PotionEffect> effect = p.getActivePotionEffects();
		final Iterator<PotionEffect> iterator = effect.iterator();
		Boolean flag = Boolean.valueOf(false);
		while (iterator.hasNext()) {
			final PotionEffect element = iterator.next();
			if (element.toString().toUpperCase().contains("NIGHT_VISION")) {
				flag = Boolean.valueOf(true);
				break;
			}
		}
		if (!flag.booleanValue()) {
			if (blockid == Material.AIR) {
				return;
			}
			if (blockid == Material.STONE || blockid == Material.GOLD_ORE || blockid == Material.IRON_ORE || blockid == Material.COAL_ORE || blockid == Material.DIAMOND_ORE
					|| blockid == Material.REDSTONE_ORE || blockid == Material.LAPIS_ORE || blockid == Material.EMERALD_ORE) {
				e.setCancelled(true);
				p.sendMessage(plugin.getfullmsg("Nightvision.Tip"));
			}
		}
	}
}