package cn.citycraft.SimpleProtect.command;

import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandException;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import cn.citycraft.PluginHelper.commands.BaseCommand;
import cn.citycraft.SimpleProtect.SimpleProtect;

public class CommandSetSpawn extends BaseCommand {
	SimpleProtect plugin;

	public CommandSetSpawn(final SimpleProtect main) {
		super("setspawn");
		this.plugin = main;
		setOnlyPlayerExecutable();
		setDescription("配置保护插件出生点");
	}

	@Override
	public void execute(final CommandSender sender, final Command command, final String label, final String[] args) throws CommandException {
		final Location l = ((Player) sender).getLocation();
		plugin.config.set("SafeNetherDoor.World", l.getWorld().getName());
		plugin.config.set("SafeNetherDoor.X", l.getBlockX());
		plugin.config.set("SafeNetherDoor.Y", l.getBlockY());
		plugin.config.set("SafeNetherDoor.Z", l.getBlockZ());
		sender.sendMessage(plugin.pluginname + plugin.config.getMessage("SafeNetherDoor.Set"));
	}

}
